您的位置:首页 > 其它

Assemblepoj3497

2016-07-06 19:12 218 查看
Assemble
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 3463 Accepted: 1103
DescriptionRecently your team noticed that the computer you use to practice for programming contests is not good enough anymore. Therefore, you decide to buy a new computer.To make the ideal computer for your needs, you decide to buy separate components and assemble the computer yourself. You need to buy exactly one of each type of component.The problem is which components to buy. As you all know, the quality of a computer is equal to the quality of its weakest component. Therefore, you want to maximize the quality of the component with the lowest quality, while not exceeding your budget.InputOn the first line one positive number: the number of testcases, at most 100. After that per testcase:One line with two integers: 1 ≤ n ≤ 1 000, the number of available components and 1 ≤ b ≤ 1 000 000 000, your budget.n lines in the following format: “type name price quality”, where type is a string with the type of the component, name is a string with the unique name of the component, price is an integer (0 ≤price ≤ 1000 000) which represents the price of the component and quality is an integer (0 ≤ quality ≤ 1 000 000 000) which represents the quality of the component (higher is better). The strings contain only letters, digits andunderscores and have a maximal length of 20 characters.OutputPer testcase:One line with one integer: the maximal possible quality.Sample Input
1
18 800
processor 3500_MHz 66 5
processor 4200_MHz 103 7
processor 5000_MHz 156 9
processor 6000_MHz 219 12
memory 1_GB 35 3
memory 2_GB 88 6
memory 4_GB 170 12
mainbord all_onboard 52 10
harddisk 250_GB 54 10
harddisk 500_FB 99 12
casing midi 36 10
monitor 17_inch 157 5
monitor 19_inch 175 7
monitor 20_inch 210 9
monitor 22_inch 293 12
mouse cordless_optical 18 12
mouse microsoft 30 9
keyboard office 4 10
Sample Output
9
SourceNorthwestern Europe 2007
题意:这道题目给出相应的配件数,最终要求花费不超过m时组装出的电脑配件的价值的最小值的最大值是多少。直接用map处理数据,然后直接二分出答案。选择配件的时候用贪心的思路,优先选择大于等于当前价值的最小值且花费最少的配件。
#include<cstring>
#include<iostream>
#include<map>
#include<string>
#include<cstdio>
#include<algorithm>
using namespace std;
const int N=1007;
map<string ,int>type;
struct data
{
int v,c,t;
}d[N];
int n,m;
int vis[N];
bool cmp(data a,data b)
{
if(a.c==b.c)
return a.v>b.v;
return a.c<b.c;
}
int all;
bool ok(int x)
{
memset(vis,0,sizeof vis);
int coun=1,cost=0;
for(int i=1;i<=n;i++)
{
if(d[i].v>=x&&vis[d[i].t]==0)
{
//  printf("d[%d].t=%d    v:%d     x:%d \n",i,d[i].t,d[i].v,x);
vis[d[i].t]=1;
coun++;
cost+=d[i].c;
if(coun==all)
break;
if(cost>m)
return 0;
}
}
// printf("coun:%d   all:%d\n",coun,all);
if(cost>m)
return 0;
if(coun!=all)
return 0;
return 1;

}
char ss[40],str[40];
int main()
{
int T;
scanf("%d",&T);
while(T--)
{
type.clear();
scanf("%d%d",&n,&m);
int le=0,ri=0,mid;
all=1;
for(int i=1;i<=n;i++)
{
//   string a,b;
int c,e;
//cin>>a>>b>>c>>e;				//此处不要用cin,会超时
scanf("%s%s%d%d",ss,str,&c,&e);
if(type[ss]==0)
type[ss]=all++;
d[i].t=type[ss];
d[i].v=e;
d[i].c=c;
ri=max(ri,d[i].v);
}

sort(d+1,d+n+1,cmp);

while(le<=ri)
{
mid=(le+ri)/2;
if(ok(mid))
{
le=mid+1;
}
else
ri=mid-1;
}

printf("%d\n",le-1);
}
return 0;
}

                                            
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: